/*
 * "streamable kanji code filter and converter"
 *
 * Copyright (c) 1998,1999 HappySize, Inc. All rights reserved.
 *
 * gp
 *
 * ̃\tgEFA͊Ѓnbs[TCYɂĊJ܂BЃnb
 * s[TCÝA쌠@і쌠̒߂ɂÃ\tgEFAɊ
 * 邷ׂĂ̌𗯕ۂ錠Aɍsg܂BЃnbs[TC
 * Y͈ȉɖLɏ]āÃ\tgEFAgprIł͂Ȃ
 * qlɋ܂BlƂAȉ̏ɔẴ\tgEFAgp
 * 邱Ƃ͂ł܂B
 *
 * ̃\tgEFAuGNU Lesser General Public License (Version 2.1, February
 * 1999)vɎꂽŎgp邱ƂASĂ̕ɋ܂BuGNU Lesser
 * General Public Licensev𖞂Ȃgpɂ́AЃnbs[TCY珑
 * ɂ鋖𓾂Kv܂B
 *
 * uGNU Lesser General Public Licensev̑S͈ȉ̃EFuy[W擾ł
 * ܂BuGNU Lesser General Public LicensevƂ́A܂Library General
 * Public LicenseƌĂ΂Ă̂łB
 *     http://www.gnu.org/ --- GNUEFuTCg
 *     http://www.gnu.org/copyleft/lesser.html --- CZX
 * ̃CZX̓e킩ȂAȂɂ͎gp܂B
 *
 * ȂAЂGNUvWFNgƂ̓̊֌W܂͎咣̂
 * ͂܂B
 *
 * ۏؓe
 *
 * ̃\tgEFÁA҂ꂽE@\E\ƂڕWƂĐ݌v
 * JĂ܂Aۏ؂̂ł͂܂B̃\tgEFÁu
 * ̂܂܁v̏ԂŒ񋟂ĂAƂ΂̃\tgEFA̗LpȂ
 * ړIɍv邱ƂƂA炩̕ۏؓeAꂽÖقɎĂ
 * ꍇłĂA̕ۏ؂͖łB̃\tgEFAgpʂȂg
 * pȂʂɂāAڂ邢͊ԐڂɎ󂯂g̓IȏQAY̑Q
 * Af[^̑邢͂̑̑SĂ̑QɂẮȂQ̉\gp
 * AЂ邢͑O҂ɂČxĂꍇłĂAЂ͂̑Q̔
 * ѕUs܂B̋K͑̑SẮAʏ܂͏ʂɖۏ؁E
 * _EKɗD悵܂B
 *
 * 쌠҂̘A您юgpɂĂ̖₢킹恟
 *
 * 112-0004sy1-1-13r7F
 * Ѓnbs[TCY
 * Phone: 03-5803-2964, Fax: 03-5803-2965
 * http://www.happysize.co.jp/ mailto:info@happysize.co.jp
 *
 * ҁ
 *
 * {@ <sgk@happysize.co.jp>
 *
 * 
 *
 * 1998/11/10 sgk implementation in C++
 * 1999/4/25  sgk CŏȂB
 * 1999/4/26  sgk ̓tB^BR[h𐄒肵ȂtB^ǉB
 * 1999/6/??      ˓cɂAUnicodeT|[gB
 * 1999/6/22  sgk CZXLGPLɕύXB˓c̗ς݁B
 *
 */

/*
 *
 * streamable kanji code filter and converter
 *
 */

#ifndef	HAPPYSIZE_KANJI_CONVERSION_KANJI_H
#define	HAPPYSIZE_KANJI_CONVERSION_KANJI_H

/* mbfl : Multi Byte FiLter Liblary */

enum mbfl_no_language {
	mbfl_no_language_unknown   = 0,
	mbfl_no_language_universal = 1,
	mbfl_no_language_en_us     = 2,
	mbfl_no_language_ja_jp     = 3
};

typedef struct {
	enum mbfl_no_language no_language;
	const char *name;
	const char *(*aliases)[];
} mbfl_language;

typedef mbfl_language* mbfl_language_ptr;

enum mbfl_no_encoding {
	mbfl_no_encoding_auto   = 0,
	mbfl_no_encoding_pass   = 1,
	mbfl_no_encoding_wchar  = 2,
	mbfl_no_encoding_base64 = 3,
	mbfl_no_encoding_qprint = 4,
	mbfl_no_encoding_ucs    = 6,
	mbfl_no_encoding_en_us_ascii = 7,
	mbfl_no_encoding_ja_jp_euc   = 8,
	mbfl_no_encoding_ja_jp_sjis  = 9,
	mbfl_no_encoding_ja_jp_jis   = 10
};

typedef struct {
	enum mbfl_no_encoding no_encoding;
	const char *name;
	const char *(*aliases)[];
	const char *mime_name;
	mbfl_language_ptr planguage;
} mbfl_encoding;

typedef mbfl_encoding* mbfl_encoding_ptr;

/*
 * string to pointer to encoding description structure
 */
mbfl_encoding_ptr
mbfl_name2encoding(const char *name);

/*
 * int to pointer to encoding description structure
 */
mbfl_encoding_ptr
mbfl_no2encoding(int no_encoding);


/*
 * ɏo͂output_function
 */
extern int memory_device_output(int c, void* data);
extern int wchar_device_output(int c, void* data);

#define MBFL_MEMORY_DEVICE_ALLOC_SIZE	64

struct memory_device {
	char* buffer;	/* (char*)0ɏKvB */
	int length;		/* 0ɏKvB */
	int pos;		/* 0ɏKvB */
};

struct wchar_device {
	int* buffer;	/* (int*)0ɏKvB */
	int length;		/* 0ɏKvB */
	int pos;		/* 0ɏKvB */
};

extern int memory_device_cat(struct memory_device *pd, const char *psrc);
extern int memory_device_ncat(struct memory_device *pd, const char *psrc, int len);

/*
 *
 * output filter
 *
 */
struct mbfl_output_filter;	/* forward declaration */

struct mbfl_output_filter* mbfl_output_filter_new(
    enum mbfl_no_encoding from,		/* current encoding */
    enum mbfl_no_encoding to,		/* new encoding */
    int (*output_function)(int, void*),	/* output function */
    int (*flush_function)(void*),	/* can be NULL */
    void* data);			/* argument for *_function() */
    /*
     * tB^IuWFNg쐬BtB^ς݂̕oׂ͂Ώۂ̊֐
     * output_functionɎw肷Bo͑Ώۂobt@OsĂꍇ́A
     * flush_functionɃtbV̂߂̊֐w肷BNULLw肷
     * tbV͍sȂBL̊֐ɂ́Adataŗ^lnB
     * ̒l̓eɂĂ̓tB^͊֒mȂB
     *
     * int (*output_function)(int c, void* data)
     *     coBG[̎̓}CiXlԂƁBȂ΂OȏB
     *
     * int (*flush_function)(void*)
     *     tbVBG[̎̓}CiXlԂƁBȂ΂OȏB
     *
     */

void mbfl_output_filter_delete(struct mbfl_output_filter* filter);
    /*
     * tB^IuWFNg폜B
     * flush_functionNULLłȂ΃tbVB
     */

int mbfl_output_filter_feed(struct mbfl_output_filter* filter, int c);
    /*
     * tB^ɑ΂ĂP肱ށB
     * c0-255łKvBchar̕gɒӂ邱ƁB
     * c̒l͈̔͂R[hƂĐɂĂ͊֒mĂȂB
     * ĂяoŐӔCƁBȂꍇ̌ʂ͕sB
     * ꍇcƓlԂB
     */

int mbfl_output_filter_flush(struct mbfl_output_filter* filter);
    /*
     * tbVB߂l(*flush_function)()̒lB
     */

enum mbfl_no_encoding mbfl_output_filter_encoding(
    struct mbfl_output_filter* filter);
    /*
     * ݂̃GR[fBOi͑j𓚂B
     * fromunknownƂꍇɎĝ{̖ړIB
     */

void
mbfl_output_filter_reset(
    struct mbfl_output_filter* filter,
    enum mbfl_no_encoding from,
    enum mbfl_no_encoding to);
    /*
     * o͂̃GR[fBO؂ւB
     */

void
mbfl_output_filter_copy(
    struct mbfl_output_filter* src,
    struct mbfl_output_filter* dist);
    /*
     * filtero[ϐ̃Rs[B
     */

int
mbfl_output_filter_unknown_default(
    struct mbfl_output_filter* filter,
    enum mbfl_no_encoding dfl);
    /*
     * filter  from  auto ̏ꍇŁA
     * ͂̃GR[fBOm肵Ȃꍇ
     * ftHgw肷B
     * Ŏw肵Ȃꍇ pass ɂȂ̂
     * 񂪒ZꍇȂǂŃGR[fBO
     * 肪sm̏ꍇ͕ϊsȂB
     */


/*
 *
 * input filter
 *
 */
struct mbfl_input_filter;	/* forward */

struct mbfl_input_filter* mbfl_input_filter_new(
    enum mbfl_no_encoding from,		/* current encoding */
    enum mbfl_no_encoding to,		/* new encoding */
    int (*input_function)(void*),	/* input function */
    void* data);			/* argument for *_function() */
    /*
     * int (*input_function)(void* data)
     *     should return a char or -1 on EOF.
     */

void mbfl_input_filter_delete(struct mbfl_input_filter* filter);
    /*
     * tB^IuWFNg폜B
     */

int mbfl_input_filter_retrieve(struct mbfl_input_filter* filter);
    /*
     * returns a char, or -1 on EOF.
     */

enum mbfl_no_encoding mbfl_input_filter_encoding(
    struct mbfl_input_filter* filter);
    /*
     * ݂̃GR[fBOi͑j𓚂B
     * fromunknownƂꍇɎĝ{̖ړIB
     */

/*
 *
 * ɏo͂tB^B
 *
 * newdelete͎OAfeedflushoutput_filter̂gB
 *
 */
struct mbfl_output_filter* mbfl_output_to_memory_new(
    enum mbfl_no_encoding from,
    enum mbfl_no_encoding to);

void mbfl_output_to_memory_delete(struct mbfl_output_filter* filter);

char* mbfl_output_to_memory_result(struct mbfl_output_filter* filter);
    /*
     * _ł̌ʂ擾B
     * mallocꂽ̈悪ԂBfree͌Ăяo̐ӔCB
     * ͑sƂꍇA̎_Ő肳B
     */

/*
 *
 * kanji converter
 *
 */
char* mbfl_encoding_convert(
    enum mbfl_no_encoding from,
    enum mbfl_no_encoding to,
    const char* s);
    /*
     * ^R[hϊBmallocꂽ̈ԂB
     * ̗̈́AĂяoӔCfreeKvB
     */

/*
 *
 * identify kanji code
 *
 */
enum mbfl_no_encoding mbfl_identify_encoding(const char* s);

/*
 *
 * }`oCgΉstrlen
 *
 */
int
mbfl_strlen(
    const char* s,
    enum mbfl_no_encoding code);

/*
 *
 * }`oCgΉstrpos
 *
 */
int
mbfl_strpos(
    const char* haystack,
    const char* needle,
    int offset,
    enum mbfl_no_encoding code,
    int reverse);

/*
 *
 * }`oCgΉsubstr
 *
 */
char*
mbfl_substr(
    const char* s,
    int from,
    int length,
    enum mbfl_no_encoding code);

/*
 *
 * strcut
 *
 */
char*
mbfl_strcut(
    const char* s,
    int from,
    int length,
    enum mbfl_no_encoding code);

/*
 *
 * MIME header encode
 *
 */
struct mime_header_encoder_data;	/* forward declaration */

struct mime_header_encoder_data*
mime_header_encoder_new(
    enum mbfl_no_encoding incode,
    enum mbfl_no_encoding outcode,
    enum mbfl_no_encoding encoding);
    /*
     * GR[_쐬B
     * incode : ͂镶R[h
     * outcode : GR[fBOubNɖߍލۂ̕R[h
     * encoding : mbfl_no_encoding_base64܂mbfl_no_encoding_qprint
     */

void
mime_header_encoder_delete(struct mime_header_encoder_data *pe);
    /*
     * GR[_[폜B
     */

int
mime_header_encoder_feed(int c, struct mime_header_encoder_data *pe);
    /*
     * GR[_[ɈꕶB
     */

char*
mime_header_encoder_result(struct mime_header_encoder_data *pe);
    /*
     * _ł̌ʂ擾B
     * mallocꂽ̈悪ԂBfree͌Ăяo̐ӔCB
     */

char*
mbfl_mime_header_encode(
    enum mbfl_no_encoding incode,
    enum mbfl_no_encoding outcode,
    enum mbfl_no_encoding encoding,
    const char *s,
    const char *linefeed);
    /*
     * ^MIMEwb_[GR[hBmallocꂽ̈ԂB
     * ̗̈́AĂяoӔCfreeKvB
     * incode : s̕R[h
     * outcode : GR[fBOubNɖߍލۂ̕R[h
     * encoding : mbfl_no_encoding_base64܂mbfl_no_encoding_qprint
     * s : GR[h镶
     * linefeed : sR[hANULL̏ꍇ̓ftHg"\r\n"
     */

/*
 *
 * MIME header decode
 *
 */
struct mime_header_decoder_data;	/* forward declaration */

struct mime_header_decoder_data*
mime_header_decoder_new(enum mbfl_no_encoding outcode);
    /*
     * fR[_쐬B
     * outcode : fR[hʂo͂ɎgR[h
     */

void
mime_header_decoder_delete(struct mime_header_decoder_data *pd);
    /*
     * fR[_폜B
     */

int
mime_header_decoder_feed(int c, struct mime_header_decoder_data *pd);
    /*
     * fR[_[ɈꕶB
     */

char*
mime_header_decoder_result(struct mime_header_decoder_data *pd);
    /*
     * _ł̌ʂ擾B
     * mallocꂽ̈悪ԂBfree͌Ăяo̐ӔCB
     */

char*
mbfl_mime_header_decode(
    enum mbfl_no_encoding outcode,
    const char *s);
    /*
     * ^MIMEwb_[GR[hubNfR[hB
     * mallocꂽ̈ԂB
     * ̗̈́AĂяoӔCfreeKvB
     * outcode : o͂镶R[h
     * s : fR[h镶
     */

/*
 *
 * pƑSp̕ϊ
 *
 */
char* mbfl_ja_jp_hantozen(
    const char* s,
    int mode,
    enum mbfl_no_encoding code);

#endif	/* HAPPYSIZE_KANJI_CONVERSION_KANJI_H */
